/* this struct /should/ allow me to let unencrypted ims happen with a minimal disturbance */
#include <stdio.h>
#include <string.h>

#define  BK	1  /* this is the header for a blaim key & prime */
#define  KR	2  /* this is a key request header */
#define  BF	3  /* this is a blaim encrypted message */
#define  VR	4  /* version request */
#define  BV	5  /* version reply **not used in this version */
#define  KE	6  /* kill encryption, sent to peer on /off */

struct  aim_people *find_struct(char * who)
{
	struct aim_people *moof;
	for (moof = blaim_people; moof; moof=moof->next)
	{
		if(!strcmp(who,moof->username)) return moof;
	}
	return NULL; /* oh shit.. we cant find this person */
}

/*###################################################################
	ismessagetagged()
	int = ismessagetagged(char * message)	
	message = the message to check for a tag
	
	returns 0 if the message is not  tagged
	returns n where N is the tag number
	
	if the message is tagged then the the message variable is returned with the tag removed
	
	Sat Feb  3 17:16:56 EST 2001: tested and working -phar
	
####################################################################*/



int ismessagetagged(char * message)
{
char tag[4];
int  tagnum = 0;
	
	memcpy(tag,message,4);
	
	/* try finding the tag */
	if(!strncmp(":BK:",tag,4))tagnum = 1;	
        if(!strncmp(":KR:",tag,4))tagnum = 2;
        if(!strncmp(":BF:",tag,4))tagnum = 3;
        if(!strncmp(":VR:",tag,4))tagnum = 4;
        if(!strncmp(":BV:",tag,4))tagnum = 5;
        if(!strncmp(":KE:",tag,4))tagnum = 6;

        /* if theres a tag remove it.. if not. then leave it alone */
        if(tagnum > 0) memmove(message,message+4,strlen(message)-3);
	
	return tagnum;
}

/*######################################################################
	these functions are the actual encryption\decryption loops..
	i would like this to be cleaner and slicker then it was in
	the previous version... please bear with me
######################################################################*/

block_encrypt(BLOWFISH_CTX *ctx, char cleartext[], char *cyphertext)
{
int n = strlen(cleartext),junk = n,i,clearlen = (n + (8 -(n % 8))),q;
union charlong buff;
char corruptionbuffer[10];
char moofy[7] = "\0";

	srand(time(NULL));
	memcpy(buff.string,cleartext,n+1);
	while (++junk < clearlen - 1){buff.string[junk] = (char) rand();}
	junk = clearlen /4;
	for ( i = 0; i  < junk; i = (i+2))
	{
		Blowfish_Encrypt(ctx, &buff.blowln[i],&buff.blowln[i + 1]);
		sprintf(moofy,"%08lX%08lX", buff.blowln[i] ,buff.blowln[i+1]);
		strcat(cyphertext,moofy);
	}
}



block_decrypt (BLOWFISH_CTX *ctx,char cyphertext[], char *output)
{
union charlong buff;
char corruptionbuffer[10];
long l,r;
char tempbuff1[9] = "\0",tempbuff2[9]= "\0";
int i,n,e;
	
	memcpy(buff.string,cyphertext,strlen(cyphertext)+1);
	n = (strlen(cyphertext)  /8);
	
	for(i = 0; i < n ; i = (i + 2))
	{
		memcpy(tempbuff1,(buff.string + (i * 8)),8);
                sscanf(tempbuff1, "%08lX", &buff.blowln[i]);
	        memcpy(tempbuff2,(buff.string + ((i+1) * 8) ),8);
                sscanf(tempbuff2, "%08lX",&buff.blowln[i+1]);
		Blowfish_Decrypt(ctx, &buff.blowln[i],&buff.blowln[i+1] );
	}
	
	memcpy(output,buff.string,strlen(cyphertext));	
}

void getkey(char *who)
{
char keystringbuff[255]= "\0";
struct conversation *c = find_conversation(who);

		write_to_conv(c, "<B>BLAIM:</B> Requesting Key...", WFLAG_SYSTEM, NULL);
		strcat(keystringbuff,":KR:");
		strcat(keystringbuff, mpz_get_str((char *) NULL, 16, pubkey));
		strcat(keystringbuff,"@");
		strcat(keystringbuff,mpz_get_str((char *) NULL, 16, localprime));
	        serv_send_im(c->gc,who,keystringbuff,0);
	
 }


/*############################################
	this function does nothing but
	generate a random number..
#############################################*/

void get_random(mpz_t rnum, unsigned int bits)
{
	FILE *rand_input;
        gmp_randstate_t state;
        mpz_t i;
        mpz_init(i);
	mpz_init(rnum);

	rand_input = fopen("/dev/random", "r");
        gmp_randinit(state, 0, 128);
        gmp_randseed_ui(state, getc(rand_input));
        mpz_urandomb(i, state, bits);
	mpz_set(rnum,i);
	mpz_clear(i);
	fclose(rand_input);	
	mpz_setbit(rnum,bits -1);
	gmp_randclear(state); /* call this a memory leak fixed */
}


/*##############################################
	this one generates a prime numnber
	using the random function
###############################################*/


void get_prime(mpz_t ret, unsigned int bits)
{
	mpz_t n, aux;
	mpz_init(aux);
	mpz_init(ret);
	mpz_init(n);
	get_random(n, NUM_KEY_BITS);

retry:
	mpz_add_ui(n, n, 1);
        mpz_mod_2exp(n, n, bits);
        mpz_setbit(n, bits - 1);

        if (mpz_probab_prime_p(n, 10) == (1 || 2))
        {
                /* Fermat Test */
                mpz_set_ui(aux, 2);
                mpz_powm(aux, aux, n, n);
                if (mpz_cmp_ui(aux, 2) == 0)
		{
			mpz_clear(aux);
			mpz_set(ret,n);
                }
		else
                {
                        mpz_clear(aux);
                        mpz_clear(n);
                        goto retry;
                }
        }
        else goto retry;

}
